<html>
<head>
<title>OgreMeshSerializer.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreMeshSerializer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreMeshSerializer_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __MeshSerializer_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __MeshSerializer_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreSerializer_8h.html">OgreSerializer.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreMeshSerializerImpl_8h.html">OgreMeshSerializerImpl.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00038"></a>00038     
<a name="l00039"></a>00039     <span class="keyword">class </span>MeshSerializerListener;
<a name="l00040"></a>00040     
<a name="l00042"></a><a class="code" href="namespaceOgre.html#ac036050d60e78ed73d02e95fe79884a7">00042</a>     <span class="keyword">enum</span> <a class="code" href="namespaceOgre.html#ac036050d60e78ed73d02e95fe79884a7" title="Mesh compatibility versions.">MeshVersion</a> 
<a name="l00043"></a>00043     {
<a name="l00045"></a><a class="code" href="namespaceOgre.html#ac036050d60e78ed73d02e95fe79884a7ad0d24c88b7b4e8907d7b03ca9e4f87d4">00045</a>         <a class="code" href="namespaceOgre.html#ac036050d60e78ed73d02e95fe79884a7ad0d24c88b7b4e8907d7b03ca9e4f87d4" title="Latest version available.">MESH_VERSION_LATEST</a>,
<a name="l00046"></a>00046         
<a name="l00048"></a><a class="code" href="namespaceOgre.html#ac036050d60e78ed73d02e95fe79884a7a6aecc8aa7824aab71d8956f91f69854b">00048</a>         <a class="code" href="namespaceOgre.html#ac036050d60e78ed73d02e95fe79884a7a6aecc8aa7824aab71d8956f91f69854b" title="OGRE version v1.8+.">MESH_VERSION_1_8</a>,
<a name="l00050"></a><a class="code" href="namespaceOgre.html#ac036050d60e78ed73d02e95fe79884a7a0293a379395df95e09c920bd751ee576">00050</a>         <a class="code" href="namespaceOgre.html#ac036050d60e78ed73d02e95fe79884a7a0293a379395df95e09c920bd751ee576" title="OGRE version v1.7+.">MESH_VERSION_1_7</a>,
<a name="l00052"></a><a class="code" href="namespaceOgre.html#ac036050d60e78ed73d02e95fe79884a7a87fbdc88b80bff5b685005912fc952d1">00052</a>         <a class="code" href="namespaceOgre.html#ac036050d60e78ed73d02e95fe79884a7a87fbdc88b80bff5b685005912fc952d1" title="OGRE version v1.4+.">MESH_VERSION_1_4</a>,
<a name="l00054"></a><a class="code" href="namespaceOgre.html#ac036050d60e78ed73d02e95fe79884a7a740322a149493f1dfc4ae893b396eeb8">00054</a>         <a class="code" href="namespaceOgre.html#ac036050d60e78ed73d02e95fe79884a7a740322a149493f1dfc4ae893b396eeb8" title="OGRE version v1.0+.">MESH_VERSION_1_0</a>,
<a name="l00055"></a>00055         
<a name="l00057"></a><a class="code" href="namespaceOgre.html#ac036050d60e78ed73d02e95fe79884a7a1650c5d2628916d49a2e5b64f97ff1ee">00057</a>         <a class="code" href="namespaceOgre.html#ac036050d60e78ed73d02e95fe79884a7a1650c5d2628916d49a2e5b64f97ff1ee" title="Legacy versions, DO NOT USE for writing.">MESH_VERSION_LEGACY</a>
<a name="l00058"></a>00058     };
<a name="l00059"></a>00059 
<a name="l00089"></a><a class="code" href="classOgre_1_1MeshSerializer.html">00089</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1MeshSerializer.html" title="Class for serialising mesh data to/from an OGRE .mesh file.">MeshSerializer</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Serializer.html" title="Generic class for serialising data to / from binary stream-based files.">Serializer</a>
<a name="l00090"></a>00090     {
<a name="l00091"></a>00091     <span class="keyword">public</span>:
<a name="l00092"></a>00092         <a class="code" href="classOgre_1_1MeshSerializer.html" title="Class for serialising mesh data to/from an OGRE .mesh file.">MeshSerializer</a>();
<a name="l00093"></a>00093         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1MeshSerializer.html" title="Class for serialising mesh data to/from an OGRE .mesh file.">MeshSerializer</a>();
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00104"></a>00104         <span class="keywordtype">void</span> exportMesh(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Mesh.html">Mesh</a>* pMesh, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename,
<a name="l00105"></a>00105             <a class="code" href="classOgre_1_1Serializer.html#a5122d5a3161fb5fd819d9a0521fe9d39" title="The endianness of written files.">Endian</a> endianMode = ENDIAN_NATIVE);
<a name="l00106"></a>00106 
<a name="l00118"></a>00118         <span class="keywordtype">void</span> exportMesh(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Mesh.html">Mesh</a>* pMesh, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; filename,
<a name="l00119"></a>00119                         <a class="code" href="namespaceOgre.html#ac036050d60e78ed73d02e95fe79884a7" title="Mesh compatibility versions.">MeshVersion</a> version,
<a name="l00120"></a>00120                         <a class="code" href="classOgre_1_1Serializer.html#a5122d5a3161fb5fd819d9a0521fe9d39" title="The endianness of written files.">Endian</a> endianMode = ENDIAN_NATIVE);
<a name="l00121"></a>00121 
<a name="l00130"></a>00130         <span class="keywordtype">void</span> exportMesh(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Mesh.html">Mesh</a>* pMesh, <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> stream,
<a name="l00131"></a>00131             <a class="code" href="classOgre_1_1Serializer.html#a5122d5a3161fb5fd819d9a0521fe9d39" title="The endianness of written files.">Endian</a> endianMode = ENDIAN_NATIVE);
<a name="l00132"></a>00132 
<a name="l00144"></a>00144         <span class="keywordtype">void</span> exportMesh(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Mesh.html">Mesh</a>* pMesh, <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> stream,
<a name="l00145"></a>00145                         <a class="code" href="namespaceOgre.html#ac036050d60e78ed73d02e95fe79884a7" title="Mesh compatibility versions.">MeshVersion</a> version,
<a name="l00146"></a>00146                         <a class="code" href="classOgre_1_1Serializer.html#a5122d5a3161fb5fd819d9a0521fe9d39" title="The endianness of written files.">Endian</a> endianMode = ENDIAN_NATIVE);
<a name="l00147"></a>00147         
<a name="l00155"></a>00155         <span class="keywordtype">void</span> importMesh(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, <a class="code" href="classOgre_1_1Mesh.html">Mesh</a>* pDest);
<a name="l00156"></a>00156 
<a name="l00158"></a>00158         <span class="keywordtype">void</span> setListener(<a class="code" href="classOgre_1_1MeshSerializerListener.html">MeshSerializerListener</a> *listener);
<a name="l00160"></a>00160         <a class="code" href="classOgre_1_1MeshSerializerListener.html">MeshSerializerListener</a> *getListener();
<a name="l00161"></a>00161         
<a name="l00162"></a>00162     <span class="keyword">protected</span>:
<a name="l00163"></a>00163         
<a name="l00164"></a><a class="code" href="classOgre_1_1MeshSerializer_1_1MeshVersionData.html">00164</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1MeshSerializer_1_1MeshVersionData.html">MeshVersionData</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">SerializerAlloc</a>
<a name="l00165"></a>00165         {
<a name="l00166"></a>00166         <span class="keyword">public</span>:
<a name="l00167"></a><a class="code" href="classOgre_1_1MeshSerializer_1_1MeshVersionData.html#a376fb9675b38c3420b05d91b20d1bf07">00167</a>             <a class="code" href="namespaceOgre.html#ac036050d60e78ed73d02e95fe79884a7" title="Mesh compatibility versions.">MeshVersion</a> <a class="code" href="classOgre_1_1MeshSerializer_1_1MeshVersionData.html#a376fb9675b38c3420b05d91b20d1bf07">version</a>;
<a name="l00168"></a><a class="code" href="classOgre_1_1MeshSerializer_1_1MeshVersionData.html#a5a29d7ee053c7464a6e7fd8f23005890">00168</a>             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1MeshSerializer_1_1MeshVersionData.html#a5a29d7ee053c7464a6e7fd8f23005890">versionString</a>;
<a name="l00169"></a><a class="code" href="classOgre_1_1MeshSerializer_1_1MeshVersionData.html#a9732bf0b28e7de7d59ed919ee082986e">00169</a>             <a class="code" href="classOgre_1_1MeshSerializerImpl.html" title="Internal implementation of Mesh reading / writing for the latest version of the .mesh format...">MeshSerializerImpl</a>* <a class="code" href="classOgre_1_1MeshSerializer_1_1MeshVersionData.html#a9732bf0b28e7de7d59ed919ee082986e">impl</a>;
<a name="l00170"></a>00170             
<a name="l00171"></a><a class="code" href="classOgre_1_1MeshSerializer_1_1MeshVersionData.html#a4c00a3c25ef178f61c05114cb48bdaf3">00171</a>             <a class="code" href="classOgre_1_1MeshSerializer_1_1MeshVersionData.html">MeshVersionData</a>(<a class="code" href="namespaceOgre.html#ac036050d60e78ed73d02e95fe79884a7" title="Mesh compatibility versions.">MeshVersion</a> _ver, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; _string, <a class="code" href="classOgre_1_1MeshSerializerImpl.html" title="Internal implementation of Mesh reading / writing for the latest version of the .mesh format...">MeshSerializerImpl</a>* _impl)
<a name="l00172"></a>00172             : version(_ver), versionString(_string), impl(_impl) {}
<a name="l00173"></a>00173             
<a name="l00174"></a><a class="code" href="classOgre_1_1MeshSerializer_1_1MeshVersionData.html#a66a30ce721b2ee48c20c30aa211e2436">00174</a>             <a class="code" href="classOgre_1_1MeshSerializer_1_1MeshVersionData.html#a66a30ce721b2ee48c20c30aa211e2436">~MeshVersionData</a>() { <a class="code" href="group__Memory.html#gad18eff671a00617b21c8e35a7f545690">OGRE_DELETE</a> impl; }
<a name="l00175"></a>00175             
<a name="l00176"></a>00176         };
<a name="l00177"></a>00177 
<a name="l00178"></a><a class="code" href="classOgre_1_1MeshSerializer.html#a3f60fad91d6793e6c3a1fd4271e88e98">00178</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;MeshVersionData*&gt;::type</a> <a class="code" href="classOgre_1_1MeshSerializer.html#a3f60fad91d6793e6c3a1fd4271e88e98">MeshVersionDataList</a>;
<a name="l00179"></a><a class="code" href="classOgre_1_1MeshSerializer.html#afb573394e4fc1f4038342d4fb77ee68c">00179</a>         <a class="code" href="classOgre_1_1MeshSerializer.html#a3f60fad91d6793e6c3a1fd4271e88e98">MeshVersionDataList</a> <a class="code" href="classOgre_1_1MeshSerializer.html#afb573394e4fc1f4038342d4fb77ee68c">mVersionData</a>;
<a name="l00180"></a>00180 
<a name="l00181"></a><a class="code" href="classOgre_1_1MeshSerializer.html#a8cdde7fa66408858eeadb72d98597414">00181</a>         <a class="code" href="classOgre_1_1MeshSerializerListener.html">MeshSerializerListener</a> *<a class="code" href="classOgre_1_1MeshSerializer.html#a8cdde7fa66408858eeadb72d98597414">mListener</a>;
<a name="l00182"></a>00182 
<a name="l00183"></a>00183     };
<a name="l00184"></a>00184 
<a name="l00192"></a><a class="code" href="classOgre_1_1MeshSerializerListener.html">00192</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1MeshSerializerListener.html">MeshSerializerListener</a>
<a name="l00193"></a>00193     {
<a name="l00194"></a>00194     <span class="keyword">public</span>:
<a name="l00195"></a><a class="code" href="classOgre_1_1MeshSerializerListener.html#ab66317427de32196be49166371e804e6">00195</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MeshSerializerListener.html#ab66317427de32196be49166371e804e6">~MeshSerializerListener</a>() {}
<a name="l00197"></a>00197         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MeshSerializerListener.html#a7322c2248cdaeba988a0d6cbdec486ee" title="Called to override the loading of the given named material.">processMaterialName</a>(<a class="code" href="classOgre_1_1Mesh.html">Mesh</a> *mesh, <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> *name) = 0;
<a name="l00199"></a>00199         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MeshSerializerListener.html#a5eab67cdf1107dece2c9bc86085b5af4" title="Called to override the reference to a skeleton.">processSkeletonName</a>(<a class="code" href="classOgre_1_1Mesh.html">Mesh</a> *mesh, <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> *name) = 0;
<a name="l00200"></a>00200     };
<a name="l00203"></a>00203 }
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
